/*
  ==============================================================================

    This file was auto-generated by the Introjucer!

    It contains the basic framework code for a JUCE plugin editor.

  ==============================================================================
*/

#include "PluginProcessor.h"
#include "PluginEditor.h"
#include "BinaryData.h"

//==============================================================================
RP2A03AudioProcessorEditor::RP2A03AudioProcessorEditor (RP2A03AudioProcessor& p)
  : gin::ProcessorEditor (p), proc (p)
{
    using AP = RP2A03AudioProcessor;
    
    for (auto pp : p.getPluginParameters())
    {
        auto uid = pp->getUid();
        gin::ParamComponent* c;
        
        if (uid == AP::paramPulse1Tune       ||
            uid == AP::paramPulse1TuneFine   ||
            uid == AP::paramPulse2Tune       ||
            uid == AP::paramPulse2TuneFine   ||
            uid == AP::paramTriangleTune     ||
            uid == AP::paramTriangleTuneFine ||
            uid == AP::paramPulse1Sweep      ||
            uid == AP::paramPulse2Sweep)
        {
            c = new gin::Knob (pp, true);
        }
        else
        {
            c = pp->isOnOff() ? (gin::ParamComponent*)new gin::Switch (pp) : (gin::ParamComponent*)new gin::Knob (pp);
        }
        
        addAndMakeVisible (c);
        controls.add (c);
    }
    
    addAndMakeVisible (&scope);
    
    setGridSize (12, 2);
    
    scope.setNumSamplesPerPixel (2);
    scope.setVerticalZoomFactor (3.0f);
    scope.setColour (gin::TriggeredScope::lineColourId, findColour (gin::PluginLookAndFeel::grey45ColourId));
    scope.setColour (gin::TriggeredScope::traceColourId + 0, findColour (gin::PluginLookAndFeel::accentColourId));
    scope.setColour (gin::TriggeredScope::envelopeColourId + 0, juce::Colours::transparentBlack);
    scope.setColour (gin::TriggeredScope::traceColourId + 1, findColour (gin::PluginLookAndFeel::accentColourId));
    scope.setColour (gin::TriggeredScope::envelopeColourId + 1, juce::Colours::transparentBlack);
}

RP2A03AudioProcessorEditor::~RP2A03AudioProcessorEditor()
{
}

//==============================================================================
void RP2A03AudioProcessorEditor::paint (juce::Graphics& g)
{
    gin::ProcessorEditor::paint (g);
}

void RP2A03AudioProcessorEditor::resized()
{
    using AP = RP2A03AudioProcessor;
    
    gin::ProcessorEditor::resized();
    
    componentForId (AP::paramPulse1Level)->setBounds (getGridArea (0, 0));
    componentForId (AP::paramPulse1DutyCycle)->setBounds (getGridArea (1, 0));
    componentForId (AP::paramPulse1Tune)->setBounds (getGridArea (2, 0));
    componentForId (AP::paramPulse1TuneFine)->setBounds (getGridArea (3, 0));
    componentForId (AP::paramPulse1Sweep)->setBounds (getGridArea (4, 0));
    componentForId (AP::paramPulse1Shift)->setBounds (getGridArea (5, 0));
    
    componentForId (AP::paramPulse2Level)->setBounds (getGridArea (0, 1));
    componentForId (AP::paramPulse2DutyCycle)->setBounds (getGridArea (1, 1));
    componentForId (AP::paramPulse2Tune)->setBounds (getGridArea (2, 1));
    componentForId (AP::paramPulse2TuneFine)->setBounds (getGridArea (3, 1));
    componentForId (AP::paramPulse2Sweep)->setBounds (getGridArea (4, 1));
    componentForId (AP::paramPulse2Shift)->setBounds (getGridArea (5, 1));

    componentForId (AP::paramTriangleLevel)->setBounds (getGridArea (9, 0));
    componentForId (AP::paramTriangleTune)->setBounds (getGridArea (10, 0));
    componentForId (AP::paramTriangleTuneFine)->setBounds (getGridArea (11, 0));
    
    componentForId (AP::paramNoiseLevel)->setBounds (getGridArea (9, 1));
    componentForId (AP::paramNoiseShort)->setBounds (getGridArea (10, 1));
    componentForId (AP::paramOutput)->setBounds (getGridArea (11, 1));

    scope.setBounds (getGridArea (6, 0, 3, 2).reduced (5));
}
